function xi = SecondOrder(beta,X)

% Utrekning av reaksjonsomfanget ved hjelp av ein 
% andregradslikning


global n

m=X(:,1);
% Konsentrasjon av MDEA [mol/L]

y=X(:,2);                                  
% Ladningsgrad [mol/mol]

lnK=EqConst(beta,X);
% Likevektskonstantar


for i = 1:n

K_1=exp(lnK(i,1));
    
a=K_1-1;
b=-m(i)*(K_1+y(i));
c=K_1*m(i)^2*y(i)*(1-y(i));
        
xi1=(-b-sqrt(b^2-4*a*c))/2*a;
xi2=(-b+sqrt(b^2-4*a*c))/2*a;

if xi1>0
    
   xi(i)=xi1;
    
else
    
   xi(i)=xi2;
    
end        

    
   
end


xi=xi';

end
