clear all
clc
close all

global A B bfixed P pfalse ptrue ap bp cp M_amin M_H2O rho_amin rho_water;


%% ----Systemvilkaar ----

M_amin =61.08;
% Molar masse til MEA [g/mol]

M_H2O =18.02;
% Molar masse til vatn [g/mol]

rho_amin =1012;
% Tettleik til MEA [g/L]

rho_water =917;
% Tettleik til vatn [g/L]


%% ----Maaleverdiar----

load data.txt

X=data;

y = X(:,2);                            
% Ladningsgrad [mol/mol]

m = X(:,3);                            
% Vektfraksjon av amin [wt%] 

T = X(:,4)+273;                        
% Temperatur [K]

m = wtToConc(m);
% Aminonsentrasjon [mol/L]

X=[y m T];
% Matrise med dei forklarande variablane
                                       
ln_p_a= log(X(:,1));                   
% CO2-Partialtrykk  [kPa] 


%% ----Reaksjonsmatriser----

% Reaksjonsmatrise; Reaksjon mellom ikkje-flyktige komponentar i
% veasjefasen


B= [  -1       -1                       %MEA          b1  
       1        0                       %MEAH +       b2 
       0        1                       %MEACOO -     b3                        
      -1       -1                       %HCO3 -       b4  
       1        0];                     %CO3 2-       b5 


% Reaksjonsmatrise; Reaksjon mellom ikkje-flyktige komponentar og
% flyktoge komponentar



A= [ -2                                 %MEA          b1  
      1                                 %MEAH +       b2 
      1                                 %MEACOO -     b3                     
      0                                 %HCO3 -       b4  
      0];                               %CO3 2-       b5             
      


%% ----Initialverdiar---

      
a=[220.95       -2.89     -69.68]';          
b=[-6265        3635.58   -6186.21 ]';
c=[-35.48       0         14.82]';
%Litteratur, [Hessen, 2010]

ap=length(a);
bp=length(b);
cp=length(c);

beta0=[a ; b ; c];


%Kan sette parameterane til ? vere konstante
%true = konstant parameter
%false = parameter som skal bli estimert

fixed=[true true true ...  
       true true true ...  
       false false false  ];
   
P=[1:length(beta0)]';
p=length(P);

bfixed = beta0(fixed);
beta0 = beta0(~fixed);
ptrue = P(fixed);
pfalse = P(~fixed);


%% ----Prametertilpassing----

op=statset('FunValCheck','off','TolFun'...
    ,1e-6,'TolX' ,1e-6,'Display' ,'iter');
       
[beta,resid,Jac,cobp,MSE]=nlinfit(X,ln_p_a,@model,beta0,op);




