
function [ln_p_a] = model(beta0,X)

global A B bfixed P pfalse ptrue ap bp cp

%----Forklarande variablar----

y=X(:,1)
% Ladningsgrad [mol/mol]

m=X(:,2)
% Aminkonsentrasjon [mol/L]

T=X(:,3)
% Temperatur [K]

n=length(y)
% Lengde av datapunkt


% ----Ukjente parameterar----

beta=zeros(P,1);
beta(pfalse)=beta0;
beta(ptrue)=bfixed;

a=beta(1:ap);
b=beta(ap+1:ap+bp);
c=beta(ap+bp+1:ap+bp+cp);


for i=1:n
    
% -----Utrekning av likevektskonstantar----

i

lnK = a+b/T(i)+c*log(T(i))  


% ----Initialkonsentrasjon----

%     b1        b2      b3            b4      b5
b0 = [(1-y(i))*m(i)   y(i)*m(i)     0    y(i)*m(i)     0]                               


%% ----Reaksjonsomfang----


options=optimset('FunValCheck','off','Display',...
    'off','TolFun', 1e-6 ,'TolX', 1e-6);
    
    xi_0=[0 0]';
    
    x = [b0 lnK(1) lnK(2)];
    
    xi = fsolve(@equilibrium,xi_0,options,x);
    
    
% Oppdaterer resultatet viss reaksjonsomfanget er negativt    
    
while imag(xi(1)) ~= 0 || real(xi(1)) <= 0 
            
    xi_0(1)=xi_0(1)+1e-6;
    
    xi=fsolve(@equilibrium,xi_0,options,x);  
    
end



while imag(xi(2)) ~= 0 || real(xi(2)) <= 0 || real(xi(1)) <= 0     
     
    xi_0(2)=xi_0(2)+1e-6;
    
    xi=fsolve(@equilibrium,xi_0,options,x); 
    
    
end

% Konsentrasjon av ikkje-flyktige komponentar
ln_b = log(b0'+B*xi);

% CO2-partialtrykk
ln_p_a(i) = lnK(3) + ln_b'*A ;


end

ln_p_a=ln_p_a';

end




